package net.knarcraft.placeholdersigns.container;

import org.bukkit.block.Sign;
import org.bukkit.block.sign.Side;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

/**
 * A record of a player's request to copy a sign
 *
 * @param player          <p>The player requesting the sign copy</p>
 * @param sign            <p>The sign the player wants to copy</p>
 * @param side            <p>The side of the sign top copy from (null = both)</p>
 * @param sourceLine      <p>The line on the source sign to copy (null = all)</p>
 * @param destinationLine <p>The line on the destination sign to overwrite</p>
 */
public record SignTextCopyRequest(@NotNull Player player, @NotNull Sign sign, @Nullable Side side,
                                  @Nullable Integer sourceLine, @Nullable Integer destinationLine) {
}
