package net.knarcraft.placeholdersigns.listener;

import net.knarcraft.placeholdersigns.PlaceholderSigns;
import net.knarcraft.placeholdersigns.container.PlaceholderSign;
import net.knarcraft.placeholdersigns.container.QueuedPlaceholderSign;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.world.ChunkLoadEvent;
import org.bukkit.event.world.ChunkUnloadEvent;
import org.jetbrains.annotations.NotNull;

import java.util.Set;

/**
 * A listener for the loading and unloading of chunks with placeholder signs
 */
public class ChunkListener implements Listener {

    @EventHandler
    public void onChunkLoad(@NotNull ChunkLoadEvent event) {
        PlaceholderSigns instance = PlaceholderSigns.getInstance();
        Set<PlaceholderSign> signsAtChunk = instance.getSignHandler().getFromChunk(event.getChunk());
        long queueTime = System.currentTimeMillis();
        for (PlaceholderSign sign : signsAtChunk) {
            instance.getUpdateQueueHandler().queueSign(new QueuedPlaceholderSign(sign, queueTime++));
        }
    }

    @EventHandler
    public void onChunkUnload(@NotNull ChunkUnloadEvent event) {
        PlaceholderSigns instance = PlaceholderSigns.getInstance();
        Set<PlaceholderSign> signsAtChunk = instance.getSignHandler().getFromChunk(event.getChunk());
        for (PlaceholderSign sign : signsAtChunk) {
            instance.getUpdateQueueHandler().unQueueSign(sign);
        }
    }

}
